package org.ow2.util.ee.metadata.war.impl.configurator;

import java.util.List;

import org.ow2.util.ee.metadata.common.impl.configurator.CommonMethodMetadataConfigurator;
import org.ow2.util.ee.metadata.war.api.IWarClassMetadata;
import org.ow2.util.ee.metadata.war.api.IWarFieldMetadata;
import org.ow2.util.ee.metadata.war.api.IWarMethodMetadata;
import org.ow2.util.ee.metadata.war.impl.WarMethodMetadata;
import org.ow2.util.scan.api.configurator.metadata.specific.ISpecificClassConfigurator;
import org.ow2.util.scan.api.metadata.structures.JMethod;

/**
 * WarMethodMetadataConfigurator.
 * @author Gael Lalire
 */
public class WarMethodMetadataConfigurator extends
        CommonMethodMetadataConfigurator<IWarClassMetadata, IWarMethodMetadata, IWarFieldMetadata> {

    /**
     * Constructor.
     * @param jMethod signature
     * @param classMetadata parent
     * @param annotationParsingDesactived annotationParsingDesactived
     * @param specificClassConfiguratorList specificClassConfiguratorList
     */
    public WarMethodMetadataConfigurator(
            final JMethod jMethod,
            final IWarClassMetadata classMetadata,
            final boolean annotationParsingDesactived,
            final List<ISpecificClassConfigurator<IWarClassMetadata, IWarMethodMetadata, IWarFieldMetadata>>
                specificClassConfiguratorList) {
        super(new WarMethodMetadata(jMethod, classMetadata), specificClassConfiguratorList);
        if (!annotationParsingDesactived) {
            registerAnnotationVisitor();
        }
    }


}
